#! --------------------------------------------------------------------------- !
#! Template description: Glass panels                                          !
#! Version:              1.00                                                  !
#! Description:          This template adds the option to convert buttons and  !
#!                       panels to a glassy look.                              !
#! --------------------------------------------------------------------------- !
#! Author:               Roel S.F. Abspoel (roel.abspoel@gmail.com)            !
#! --------------------------------------------------------------------------- !
#TEMPLATE (GlassPanels, 'Glass panels'),FAMILY('ABC')
#EXTENSION (GlobalGlassPanels,'Global Glass Panels')
#! --------------------------------------------------------------------------- !
#SHEET
#TAB ('Glass Panels')
#DISPLAY ('')
#DISPLAY ('This template allows you to add glass panels / buttons')
#DISPLAY ('to your window and is part of the article published')
#DISPLAY ('on Clarion Magazine. (http://www.clarionmag.com)')
#DISPLAY ('')
#DISPLAY ('Add the local extension to configure your panels/buttons.')
#DISPLAY ('')
#BOXED (' Version information ')
#DISPLAY ('Version:    1.00')
#DISPLAY ('Changed: June 1 2006')
#ENDBOXED
#ENDTAB
#ENDSHEET
#! --------------------------------------------------------------------------- !
#! Global Map
#! --------------------------------------------------------------------------- !
#AT (%GlobalMap)
DrawGlassPanel(LONG MyControl,BYTE DrawHeader,BYTE DrawShadow,<BYTE IsButton>)
#ENDAT
#! --------------------------------------------------------------------------
#! Program Procedures
#! --------------------------------------------------------------------------
#AT (%ProgramProcedures)
!--> Added by the Glass Panel template

DrawGlassPanel    PROCEDURE(LONG MyControl,BYTE DrawHeader,BYTE DrawShadow,<BYTE IsButton>)
OrgPixels    BYTE
CurPos       LONG
HiddenButton BYTE
  CODE
  OrgPixels = 0{PROP:PIXELS}
  0{PROP:PIXELS} = TRUE
  IF IsButton = TRUE
    MyControl{PROP:FLAT} = TRUE
    MyControl{PROP:SKIP} = TRUE
    IF ~MyControl{PROP:TIP}
      MyControl{PROP:TIP}  = MyControl{PROP:TEXT}
    END
    HiddenButton = MyControl{PROP:HIDE}
  ELSE
    MyControl{PROP:HIDE} = TRUE
  END
  IF HiddenButton = FALSE
    SetPenWidth(1)
    IF DrawShadow = TRUE
      SetPenColor(COLOR:BLACK)
    ELSE
      SetPenColor(13883352)
    END
    LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH}),MyControl{PROP:YPOS},0,(MyControl{PROP:HEIGHT}-2))
    LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH}),(MyControl{PROP:YPOS}+(MyControl{PROP:HEIGHT}-2)),-2,2)
    LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+MyControl{PROP:HEIGHT}),(MyControl{PROP:WIDTH}-3),0)
    IF DrawShadow = TRUE
      SetPenColor(COLOR:SILVER)
    ELSE
      SetPenColor(13883352)
    END
    LINE(MyControl{PROP:XPOS},MyControl{PROP:YPOS},MyControl{PROP:WIDTH},0)
    LINE(MyControl{PROP:XPOS},MyControl{PROP:YPOS},0,(MyControl{PROP:HEIGHT}-2))
    LINE(MyControl{PROP:XPOS},(MyControl{PROP:YPOS}+(MyControl{PROP:HEIGHT}-2)),3,3)
    IF DrawShadow = TRUE
      SetPenColor(COLOR:GRAY)
      LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH})+1,(MyControl{PROP:YPOS}+1),0,(MyControl{PROP:HEIGHT})-2)
      LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH})+1,(MyControl{PROP:YPOS}+MyControl{PROP:HEIGHT})-2,-3,3)
      LINE((MyControl{PROP:XPOS}+3),(MyControl{PROP:YPOS}+MyControl{PROP:HEIGHT})+1,(MyControl{PROP:WIDTH}-4),0)
      SetPenColor(COLOR:SILVER)
      LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH})+2,(MyControl{PROP:YPOS}+2),0,(MyControl{PROP:HEIGHT})-3)
      LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH})+2,(MyControl{PROP:YPOS}+MyControl{PROP:HEIGHT})-2,-4,4)
      LINE((MyControl{PROP:XPOS}+4),(MyControl{PROP:YPOS}+MyControl{PROP:HEIGHT})+2,(MyControl{PROP:WIDTH}-5),0)
    END
    IF DrawHeader = TRUE
      SetPenColor(16777215)
      LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+1),(MyControl{PROP:WIDTH}-2),0)
      LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+1),0,18)
      LINE((MyControl{PROP:XPOS}+MyControl{PROP:WIDTH})-1,(MyControl{PROP:YPOS}+1),0,18)
      SetPenColor(15592421)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+2),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+3),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+4),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(15658214)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+5),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+6),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(15921386)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+7),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+8),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(16052972)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+9),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+10),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(16184558)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+11),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+12),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(16316144)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+13),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+14),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(16579316)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+15),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+16),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(16777210)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+17),(MyControl{PROP:WIDTH}-3),0)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+18),(MyControl{PROP:WIDTH}-3),0)
      SetPenColor(15592421)
      LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+19),(MyControl{PROP:WIDTH}-3),0)
      CurPos = 20
    ELSE
      CurPos = 1
    END
    SetPenColor(16777215)
    LOOP cnt#=CURPOS TO (MyControl{PROP:HEIGHT}-20)
      LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+cnt#),(MyControl{PROP:WIDTH}-1),0)
    END
    SetPenColor(16776957)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+0)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+1)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16711162)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+2)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+3)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16645367)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+4)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+5)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16644852)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+6)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+7)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16579057)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+8)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+9)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16578798)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+10)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+11)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16578280)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+12)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+13)),(MyControl{PROP:WIDTH}-1),0)
    SetPenColor(16447207)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+14)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+15)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+16)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+1),(MyControl{PROP:YPOS}+(cnt#+17)),(MyControl{PROP:WIDTH}-1),0)
    LINE((MyControl{PROP:XPOS}+2),(MyControl{PROP:YPOS}+(cnt#+18)),(MyControl{PROP:WIDTH}-3),0)
  END
  0{PROP:PIXELS} = OrgPixels

!--> End of additon from Glass Panel template
#ENDAT
#! --------------------------------------------------------------------------- !
#! Local extension
#! --------------------------------------------------------------------------- !
#EXTENSION(LocalGlassPanels,'Glass panels'),PROCEDURE,REQ(GlobalGlassPanels(GlassPanels))
! [PROCEDURE]
! NAME Main
#! --------------------------------------------------------------------------- !
#SHEET
#TAB ('Glass panels')
#BOXED ('Create glass panels under controls:')
#BUTTON  ('Controls'),MULTI(%GPControls,%GPControl),INLINE
  #PROMPT ('Select a control: ',FROM(%Control,(%ControlType='PANEL' OR %ControlType='LIST' OR %ControlType='BUTTON' OR %ControlType='BOX'),%Control)),%GPControl,REQ
  #PROMPT ('Draw glass header', CHECK), %GPHeader, AT(10), DEFAULT(0)
  #PROMPT ('Draw shadow', CHECK), %GPSHadow, AT(10), DEFAULT(1)
#ENDBUTTON
#ENDBOXED
#ENDTAB
#TAB ('Glass buttons')
#BOXED ('Button options')
#PROMPT ('Do not update any buttons.', CHECK), %NoUpdates, AT(10), DEFAULT(1)
#ENABLE (%NoUpdates = %False)
#PROMPT ('Update all buttons on the window.', CHECK), %UpdateAll, AT(10), DEFAULT(1)
#ENABLE (%UpdateAll = %True)
#PROMPT ('Create shadows under buttons.', CHECK), %AllShadow, AT(10), DEFAULT(1)
#DISPLAY ('Exclude these buttons')
#BUTTON  ('Exclude Buttons'),MULTI(%ExclButtons,%ExclButton),INLINE
  #PROMPT ('Select a button to exclude: ',FROM(%Control,(%ControlType='BUTTON'),%Control)),%ExclButton,REQ
#ENDBUTTON
#ENDENABLE
#ENABLE (%UpdateAll = %False)
#DISPLAY ('Upgrade only these buttons')
#BUTTON  ('Buttons'),MULTI(%UpgButtons,%UpgButton),INLINE
  #PROMPT ('Select a button to upgrade: ',FROM(%Control,(%ControlType='BUTTON'),%Control)),%UpgButton,REQ
  #PROMPT ('Create shadow under button.', CHECK), %UseShadow, AT(10), DEFAULT(1)
#ENDBUTTON
#ENDENABLE
#ENDENABLE
#ENDBOXED
#ENDTAB
#ENDSHEET
#! --------------------------------------------------------------------------- !
#AT(%WindowEventHandling,'OpenWindow'),PRIORITY(1000)
#! --------------------------------------------------------------------------- !
! --------------- Calling Draw Glass Panels Routine ---------------
! When the window is resized, your controls probably are also
! resized, thus the panels need to be redrawn.
! -----------------------------------------------------------------
DO DrawGlassPanels
! -----------------------------------------------------------------
#ENDAT
#! --------------------------------------------------------------------------- !
#AT(%WindowEventHandling,'DoResize'),PRIORITY(5000)
#! --------------------------------------------------------------------------- !
! --------------- Calling Draw Glass Panels Routine ---------------
! When the window is resized, your controls probably are also
! resized, thus the panels need to be redrawn.
! -----------------------------------------------------------------
DO DrawGlassPanels
! -----------------------------------------------------------------
#ENDAT
#! --------------------------------------------------------------------------- !
#AT(%ProcedureRoutines),PRIORITY(4000)
#! --------------------------------------------------------------------------- !
#DECLARE (%UpgradeTheButtons)
#DECLARE (%ControlNr)
#DECLARE (%SheetNr)
#DECLARE (%SheetName)
! ------------------- Draw Glass Panels Routine -------------------
DrawGlassPanels	Routine
! -----------------------------------------------------------------
! This routine draws the glass panels and buttons on your window.
! -----------------------------------------------------------------
 BLANK() ! This clears all the drawings on your window
#FOR(%GPControls)
 DrawGlassPanel(%GPControl,%GPHeader,%GPSHadow,FALSE)
#ENDFOR
#IF (%UpdateAll = %FALSE)
#FOR(%UpgButtons)
  #IF (%UseShadow = %TRUE)
 DrawGlassPanel(%UpgButton,FALSE,1,TRUE)
  #ELSE
 DrawGlassPanel(%UpgButton,FALSE,0,TRUE)
  #ENDIF
#ENDFOR
#ELSIF (%UpdateAll = %TRUE)
#SET(%SheetNr,0)
#FOR(%CONTROL)
#IF (%ControlType='BUTTON')
  #SET(%UpgradeTheButtons,1)
  #FOR(%ExclButtons)
    #IF (%CONTROL = %ExclButton)
      #SET(%UpgradeTheButtons,0)
    #ENDIF
  #ENDFOR
  #IF (%UpgradeTheButtons = 1)
    #IF (%AllShadow = %TRUE)
 DrawGlassPanel(%CONTROL,FALSE,1,TRUE)
    #ELSE
 DrawGlassPanel(%CONTROL,FALSE,0,TRUE)
    #ENDIF
  #ELSE
 ! %CONTROL is in the exclude list..
  #ENDIF
#ENDIF
#ENDFOR
#ENDIF
 DISPLAY
! -------------------------------------------------------------
! End of additon from Glass Panel template
! -------------------------------------------------------------
#ENDAT