# File: TransferAPV.py
import sys
import glob
import os
import win32process
import win32event
import win32con
import win32api
import win32file
import win32pdhutil
import time

def BGTransfert(hugeFileName):
    """ Read the current directory for APV files, and build a TXA from them, with hugeFilename +.TXA being the file being built"""
    hugeFile = open (hugeFileName, "w")
    # we work from the current directory, as it's were we are when we call this
    for fileName in glob.glob('*.apv'):
        #
        # Check to avoid including the hugeFile itself
    	#
        if (fileName != hugeFileName):
            #
	    # We open the file to be concatened
            #
            fileInput = open(fileName,"r") 
            if (fileInput):
                #
                # We concatenate adding the HTML comment
    	        #                
                for line in fileInput.readlines():
                    hugeFile.write(line)
    		    #
                    # We close the file concatened
                    #
                    fileInput.close()
            else:
                print fileInput+" does'nt exit, it is skiped"
    #
    # We close the file in which we have concatenated the others.
    #
    hugeFile.close ()
    print "Temporary " + hugeFileName+ " created."
    

def ParseForModules(AppOptionsFile,hugeFileName):
	"""here I want to build an array from reading the Application Options file, which contains the project.
   That way I can find what modules are needed, and have them in the correct order.
   I should also be able to complain and stop if one file in here is missing which is impossible to do by just reading the directory."""
    
   # First, start by building a list with the name of the Application Options file
	TXAToCompile =[AppOptionsFile]
   # Then, open what will be our TXA file
	hugef=open(hugeFileName,"wb")
   # Open the Application Options file to read it
	OptionsFile = open(AppOptionsFile, "r")
   # Check that it exists
	if (OptionsFile):
		for line in OptionsFile:
			# split each line in regard of the spaces
			myline = line.split(" ")
			# #compile instruction has a space before the file name which is in between ""
			if myline[0] == '#compile':
				# Remove (strip) the "" around the filename (" = chr34)
				mymodule = myline[1].strip(chr(34))
				# Keep only the filename itself and remove the extension (They are CLW in the project)
				modulename = mymodule.split(".")
				# Check that the file exists in the directory
				for element in glob.glob('*.APV'):					
					if modulename[0].upper() + '.APV' == element.upper():
						filename = modulename[0] + '.APV'
						# And append to the list for each file matching the criteria
						TXAToCompile.append(filename)
						# pretty cool, now I have my modules in the order they are in the project, and I know they exists in he directory,
						# I can now safely build my TXA.		    		    
		       
		for filename in TXAToCompile:
			#print filename
			smallfile=open(filename,"rb")
			s=smallfile.read()
			hugef.write(s)
			smallfile.close()
	
	hugef.close()
	#print "Temporary " + hugeFileName+ " created."						    
	OptionsFile.close()

def RebuildAPP(AppName):
    # I need to be able to find that file just looking at the "Application Options" thing, nothing else.
    myEnv = os.getenv('c6root')
    SplitAppName = os.path.split(AppName)
    TXAToUse = AppName +'\\cvs'+SplitAppName[1]+'.TXA'
    #RebuildDCT(SplitAppName[1]+'-Application Options.APV')    
    ParseForModules(SplitAppName[1]+'-Application Options.APV',TXAToUse)
    os.chdir('..\..')    
    mycurdir = os.getcwd()
    TXAToRebuild = "cvs" + SplitAppName[1] + ".TXA" 
    win32file.CopyFile(TXAToUse, TXAToRebuild,0)
    os.remove(TXAToUse)
    AppToBuild = SplitAppName[1] + ".APP"
    win32api.ShellExecute(0, # No parent Window
			  "open", # action to perform
			  myEnv +"\\BIN\\BG_DDE_CVS.EXE", # application to run
			  "/A TXA=" + TXAToRebuild + " App=" + AppToBuild, # parameters
			  mycurdir,# Initial directory to run the app from
			  0) # if application should be shown
    
def RebuildDCT(aDirectory):
	app = os.path.split(aDirectory)
	myEnv = os.getenv('c6root')
	AppOptionsFile = app[1]+'-Application Options.APV'
	savedpath = os.getcwd()
	ParseForDCV(AppOptionsFile)
	for filename in glob.glob('*.TXD'):
		# Check if after ParseForDCV I actualluy have a TXD there.
		# If yes, find his name, copy it to the proper place, and rebuild it.
		DCTName = os.path.split(filename)
		DCTLessExtension = DCTName[1].strip(".TXD")
		DCTToBuild = DCTLessExtension.strip("cvs") + ".DCT"
		os.chdir('..\..')
		mycurdir = os.getcwd()		
		win32file.CopyFile(savedpath + "\\" +filename, filename,0)
		os.remove(savedpath + "\\" +filename)
		win32api.ShellExecute(0, # No parent Window
			  "open", # action to perform
			  myEnv +"\\BIN\\BG_DDE_CVS.EXE", # application to run
			  "/D TXD=" + DCTName[1] + " Dct=" + DCTToBuild, # parameters
			  mycurdir,# Initial directory to run the app from
			  0) # if application should be shown
	
	os.chdir(savedpath)
	    
 
def ParseForDCV(AppOptionsFile):
	# here I assume I have only one DCT per application. Should be a safe assumption           
   # Open the Application Options file to read it
   OptionsFile = open(AppOptionsFile, "r")
   # Check that it exists
   if (OptionsFile):        	
      for line in OptionsFile:
	   # split each line in regard of the spaces
	   myline = line.split(" ")	    
	   # #compile instruction has a space before the file name which is in between ""
	   if myline[0] == 'DICTIONARY':		
			# Remove (strip) the "" around the filename (" = chr34)
			mydictionnary = myline[1].strip(chr(39))		
			# Keep only the filename itself and remove the extension (They are CLW in the project)
			modulename = mydictionnary.split(".")
			# Check that the file exists in the directory
			for element in glob.glob('*.DCV'):
				if modulename[0].upper() + '.DCV' == element.upper():
					filename = modulename[0] + '.DCV'
					TXDname = "cvs" + modulename[0] + '.TXD'
					hugef=open(TXDname,"wb")
					if len(filename) != 0:
						#print filename
						smallfile=open(filename,"rb")
						s=smallfile.read()
						hugef.write(s)
						smallfile.close()
						hugef.close()
				else:
					print "ERROR: The DCV file found does not match the dictionary declared in Application Options. Nothing done!"
			
			
   #print "Temporary " + hugeFileName+ " created."						    
   OptionsFile.close()

def WaitForProcess():
   #time.sleep(0.5)
   timeout = 1500
   handles = []
   pids = win32pdhutil.FindPerformanceAttributesByName("BG_DDE_CVS")    
   for pid in pids:	
		handle = win32api.OpenProcess(win32con.PROCESS_ALL_ACCESS, 1,pid)
		handles.append(handle)
	
   for handle in handles:
		while 1:
			result = win32event.WaitForSingleObject(handle, timeout)
			if result == win32event.WAIT_OBJECT_0:
				#print "Process terminated"
				break
			elif result == win32event.WAIT_TIMEOUT:
				#print "Process Timed out"
				break
	    
	
	
	
    
    
