#TEMPLATE(dcRules,'DinamiComp - External Rules Templates'),FAMILY('ABC')
#!--------------------------------------------------------------------------
#!
#! All Rights Reserved World Wide
#! 
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                               APPLICATION EXTENSION
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!
#EXTENSION(dcExternalRulesGlobal,'DinamiComp''s External Business Rules-Global'),APPLICATION(GlobalBusinessRulesManager)
#!
#! The PREPARE section includes calls that must be performed to correctly display the prompts in your
#! template when accessed within your application
#!------------------------------------------------------------------------------------------------------------------------
#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassDefaults(ABC),'dcRulesClass','dcRulesObj:'&%ActiveTemplateInstance,'dcRulesClass')
#ENDPREPARE
#!
#!  The ATSTART section, albeit a copy of the PREPARE section, performs the same calls but, unlike the
#!  #PREPARE section that is only used while accessing the template prompts, this section is processed
#!  prior to actual source code generation
#!------------------------------------------------------------------------------------------------------------------------
#ATSTART 
  #!  Purges a bunch of template symbols which are then reloaded through a #SERVICE call into C55TPLS.DLL
  #CALL(%ReadABCFiles(ABC)) 
  #!  Verifies the instance of the class referenced by the template
  #CALL(%SetClassDefaults(ABC),'dcRulesClass','dcRulesObj:'&%ActiveTemplateInstance,'dcRulesClass')
#ENDAT
#!
#SHEET
#! Custom for this template
#!------------------------------------------------------------------------------------------------------------------------
#TAB('General')
    #INSERT  (%SETCC)
    #INSERT  (%SETAPP)
    #BOXED   ('Debugging'),section,AT(,65,,20)
       #PROMPT  ('Disable All DinamiComp Templates',Check),%DisableAll,AT(10)
    #ENDBOXED
#ENDTAB
#TAB('Queue/In-Memory')
    #DISPLAY ('')
    #BOXED('In-Memory'),Section
       #DISPLAY ('Use In memory driver in place of Global Queue')
       #DISPLAY ('Will fix Threading issues.')
       #DISPLAY ('Should have TPS/SQL files as well as In-Memory')
       #PROMPT  ('Use In-Memory Driver',CHECK),%UseIMD,At(10,30)
       #ENABLE(%UseIMD=%TRUE)
          #DISPLAY ('Select "Rules" Filename')
          #PROMPT  ('',FILE),%IMDRules,REQ
          #DISPLAY ('Select "Rules" Key')
          #PROMPT  ('',@S255),%IMDRULEKEY,REQ
          #DISPLAY ('Select "Controls Per Rule" Filename')
          #PROMPT  ('',FILE),%IMDControlesPerRule,REQ,WHENACCEPTED(%StripExclamation(%IMDControlesPerRule))
          #DISPLAY ('Select "Controls Per Rule" Key')
          #PROMPT  ('',@S255),%IMDControlesPerRuleKey,REQ
          #DISPLAY ('Select "Override Procedures Per Rule" Filename')
          #PROMPT  ('',FILE),%IMDOverrideProcPerRule,REQ,WHENACCEPTED(%StripExclamation(%IMDOverrideProcPerRule))
          #DISPLAY ('Select "Override Procedures Per Rule" Key')
          #PROMPT  ('',@S255),%IMDOverrideProcPerRuleKey,REQ
       #ENDENABLE
    #ENDBOXED           
#ENDTAB
#TAB('Rule Settings')
    #DISPLAY ('')
    #DISPLAY ('')
    #PROMPT  ('Error-indicator Image',OPENDIALOG('Select error-indicator image file','Icons (*.ico)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalErrorIndicatorImage,DEFAULT('BRuleNo.ico')
    #PROMPT  ('Default Distance from Right:',SPIN(@n3,0,999)),%GlobalRuleOffSetRight,REQ,DEFAULT(3)
    #PROMPT  ('Name:',@s255),%RuleBaseName,REQ,Default('MyGlobalRules')
    #PROMPT  ('Description:',@s255),%RuleBaseDescription,REQ,Default('GlobalRules')
    #PROMPT  ('Mode:',OPTION),%GlobalRulesTemplateMode,AT(4,,192)
    #PROMPT  ('Original',RADIO)
    #PROMPT  ('Clone',RADIO)
    #PROMPT  ('Header Icon:',OPENDIALOG('Select an Icon for a Header Icon','Icons (*.ICO)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalViewRulesHeaderIcon,REQ,DEFAULT('BRules.ico')
    #PROMPT  ('Valid Rule Icon:',OPENDIALOG('Select an Icon for a Valid Rule','Icons (*.ICO)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalViewRulesValidRuleIcon,REQ,DEFAULT('BRuleOk.ico')
    #PROMPT  ('Broken Rule Icon:',OPENDIALOG('Select an Icon for a Broken Rule','Icons (*.ICO)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalViewRulesBrokenRuleIcon,REQ,DEFAULT('BRuleNo.ico')
#ENDTAB
#TAB('Global &Objects')
    #!  This adds hidden prompts required by calls within the template
    #BOXED('Default Tag Class prompts'),AT(0,0),WHERE(%False),HIDE
       #! Define and set basic symbols to handle this ABC compliant tagging class.
       #INSERT(%OOPHiddenPrompts(ABC))
    #ENDBOXED
    #!  Visible #PROMPTs for ABC Handling
    #BUTTON('&External Rules Class'),AT(,30,170)
      #WITH(%ClassItem,'dcRulesClass' & %ActiveTemplateInstance)
        #INSERT(%GlobalClassPrompts(ABC)) 
      #ENDWITH 
    #ENDBUTTON 
#ENDTAB
#ENDSHEET

#!------------------------------------------------------------------------------------------------------------------------
#AT(%AfterGlobalIncludes)
   INCLUDE('ABRULE.INC'),ONCE
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%GlobalData)
  #CASE(%ProgramExtension)
  #OF('DLL')
    #IF(%GlobalExternal)                              #!DLL with global data external
      #IF(%ExternalSource='Dynamic Link Library (DLL)')
GlobalRule           LONG,EXTERNAL,DLL(dll_mode),THREAD

#IF(%UseIMD=%FALSE)
#INSERT(%SETRuleQExt)
#ENDIF
      #ELSE
GlobalRule           LONG,EXTERNAL,THREAD
      #ENDIF
    #ELSE                                             #!DLL with export global data
GlobalRule           LONG,THREAD

#IF(%UseIMD=%FALSE)
#INSERT(%SETRuleQ)
#ENDIF

    #ENDIF
  #OF('LIB')
    #IF(%GlobalExternal)                              #!LIB with global data external
      #IF(%ExternalSource='Dynamic Link Library (DLL)')
GlobalRule           LONG,EXTERNAL,DLL(dll_mode),THREAD

#IF(%UseIMD=%FALSE)
#INSERT(%SETRuleQExt)
#ENDIF

      #ELSE
GlobalRule           LONG,EXTERNAL,THREAD
      #ENDIF
    #ELSE                                             #!LIB with global data local
GlobalRule           LONG,THREAD

#IF(%UseIMD=%FALSE)
#INSERT(%SETRuleQ)
#ENDIF

    #ENDIF
  #OF('EXE')
    #IF(%GlobalExternal)                              #!EXE with global data external
      #IF(%ExternalSource='Dynamic Link Library (DLL)')
GlobalRule           LONG,EXTERNAL,DLL(dll_mode),THREAD

#IF(%UseIMD=%FALSE)
#INSERT(%SETRuleQExt)
#ENDIF

      #ELSE
GlobalRule           LONG,EXTERNAL,THREAD
      #ENDIF
    #ELSE                                             #!EXE with global data local
GlobalRule           LONG,THREAD

#IF(%UseIMD=%FALSE)
#INSERT(%SETRuleQ)
#ENDIF

    #ENDIF
  #ENDCASE
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%BeginningExports)
  #IF(NOT %GlobalExternal)
$GLOBALRULE                                             @?
  #ENDIF
#ENDAT

#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                Procedure Extension
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#EXTENSION(dcExternalRulesProcedure,'DinamiComp''s Check External Rules-Procedure')
#!
#SHEET
    #PROMPT('Check Rules After Open Window',Check),%LocalRuleCheckAfterOpenWindow,AT(10),DEFAULT(1)
    #PROMPT('Check Rules After Fields Change',Check),%LocalRuleCheckAfterFieldsChange,AT(10),DEFAULT(1)
    #PROMPT('Check Rules Before Updating Record',CHECK),%LocalRuleCheckBeforeUpdate,DEFAULT(1),AT(10)
#ENDSHEET

#!------------------------------------------------------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
  #IF(%GlobalErrorIndicatorImage)
      #PROJECT(%GlobalErrorIndicatorImage)
  #ENDIF
  #IF(%GlobalViewRulesHeaderIcon)
      #PROJECT(%GlobalViewRulesHeaderIcon)
  #ENDIF
  #IF(%GlobalViewRulesValidRuleIcon)
      #PROJECT(%GlobalViewRulesValidRuleIcon)
  #ENDIF
  #IF(%GlobalViewRulesBrokenRuleIcon)
      #PROJECT(%GlobalViewRulesBrokenRuleIcon)
  #ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%LocalDataClassData)
BusinessRulesManager  RulesManager
%RuleBaseName         RulesCollection   !Business Rule Manager for %RuleBaseDescription

LocalWindowQueue         QUEUE,PRE(LWQ)
ControlName                STRING(50)
ControlEquate              UNSIGNED
                         END
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(6500)
#Embed(%StartApplyingRules,'Start applying the Rules')
 #!#IF(Records(RulesQueue) > 1)
 BIND('Action',ThisWindow.Request)
 %RuleBaseName.SetErrorImage('~%GlobalErrorIndicatorImage')
 %RuleBaseName.SetDescription('%RuleBaseDescription')
 #!#EndIF
 #!Use ControlName because that will leave of List boxes ect
 Free(LocalWindowQueue)
 #FOR(%Control)
    #IF(%ControlUse = '')
   LWQ:ControlName = Upper(Sub('%control',2,Len('%control')))
    #Else
   LWQ:ControlName = Upper('%ControlUse')
    #ENDIF
   LWQ:ControlEquate = %Control
   Add(LocalWindowQueue,LWQ:ControlName)
 #ENDFOR

#Embed(%BeforeApplyingRules,'Before applying the Rules')
  !Run through rules
  #IF(%UseIMD=%FALSE)
  Loop I# = 1 to Records(RulesQueue)
     Get(RulesQueue,I#)
     If not error()
        !Check if rule's control is on screen
        LWQ:ControlName = Upper(RQ:ControlName)
        Get(LocalWindowQueue,LWQ:ControlName)
        If not error()
#Embed(%CheckProcBeforeApplyingRules,'Check Procedure Before applying the Rules')
           !If rule's control is on screen - add rule
           !Check if rule is not overridden on this procedure
           RPQ:SysIdRule     = RQ:SysIdRule
           RPQ:ProcedureName = Upper('%Procedure')
           Get(RulesProcQueue,RPQ:SysIdRule,RPQ:ProcedureName)
           If error()
              !Procedure is not overridden - add Rule
#Embed(%CheckProcNotOverriddenApplyRules,'Check Procedure Not Overridden Apply the Rules')
              %RuleBaseName.AddRule(RQ:SysIdRule,Clip(RQ:RuleDescription),Clip(RQ:RuleExpression),LWQ:ControlEquate,RQ:Offset)
              !Check rule's rule-action-control
              RCQ:SysIdRule = RQ:SysIdRule
              Get(RulesControlQueue,RCQ:SysIdRule)
              If not error()
                 Position# = Pointer(RulesControlQueue) + 1
                 Loop
                    !If rule's rule-action-control is on window - add control to rule
                    LWQ:ControlName = RCQ:ControlName
                    Get(LocalWindowQueue,LWQ:ControlName)
                    If not error()
                       %RuleBaseName.AddControlToRule(RCQ:SysIdRule,LWQ:ControlEquate,RCQ:RuleAction)
                    End
                    Get(RulesControlQueue,Position#)
                    If error() or RCQ:SysIdRule <> RQ:SysIdRule then break.
                    Position# += 1
                 End
              End
           End
        End
     End
  End
  #ELSE
  #!IMD
#Embed(%CheckIfRulesBeforeApplyingRulesB,'Check if Rules Before applying the Rules - Begin')
  Access:%IMDRules.Open()
  Access:%IMDRules.UseFile()
  IMDRUL:SysIdRule = 0
  Set(%IMDRULEKEY,%IMDRULEKEY)
  Loop 
     If Access:%IMDRules.Next() <> Level:Benign THEN BREAK.
     !Check if rule's control is on screen
     LWQ:ControlName = Upper(IMDRUL:ControlName)
     Get(LocalWindowQueue,LWQ:ControlName)
     If not error()
#Embed(%CheckProcBeforeApplyingRules,'Check Procedure Before applying the Rules')
        !If rule's control is on screen - add rule
        !Check if rule is not overridden on this procedure
        IMDOPR:SysIdRule     = IMDRUL:SysIdRule
        IMDOPR:ProcedureName = Upper('%Procedure')
        Access:%IMDOverrideProcPerRule.TryFetch(%IMDOverrideProcPerRuleKey)
        If error()
           !Procedure is not overridden - add Rule
#Embed(%CheckProcNotOverriddenApplyRules,'Check Procedure Not Overridden Apply the Rules')
           %RuleBaseName.AddRule(IMDRUL:SysIdRule,Clip(IMDRUL:RuleDescription),Clip(IMDRUL:RuleExpression)|
                                 ,LWQ:ControlEquate,IMDRUL:Offset)
           !Check rule's rule-action-control
           IMDCPR:SysIdRule = IMDRUL:SysIdRule
           Set(%IMDControlesPerRuleKey,%IMDControlesPerRuleKey)
           Loop
              If Access:%IMDControlesPerRule.Next() <> Level:Benign THEN BREAK.
              If IMDCPR:SysIdRule <> IMDRUL:SysIdRule then break.
#Embed(%CheckProcControlApplyRulesB,'Check Procedure Control Apply the Rules - Begin')
              !If rule's rule-action-control is on window - add control to rule
              LWQ:ControlName = IMDCPR:ControlName
              Get(LocalWindowQueue,LWQ:ControlName)
              If not error()
                 %RuleBaseName.AddControlToRule(IMDRUL:SysIdRule,LWQ:ControlEquate,IMDCPR:RuleAction)
              End
#Embed(%CheckProcControlApplyRulesE,'Check Procedure Control Apply the Rules - End')
           End
        End
     End
  End
  Access:%IMDRules.Close()
#Embed(%CheckIfRulesBeforeApplyingRulesE,'Check if Rules Before applying the Rules - End')
  #END
#Embed(%AfterApplyingRules,'After applying the Rules')
%RuleBaseName.SetEnumerateIcons('~%GlobalViewRulesHeaderIcon','~%GlobalViewRulesValidRuleIcon','~%GlobalViewRulesBrokenRuleIcon')
BusinessRulesManager.AddRulesCollection(%RuleBaseName)
BusinessRulesManager.SetEnumerateIcons('~%GlobalViewRulesHeaderIcon','~%GlobalViewRulesValidRuleIcon','~%GlobalViewRulesBrokenRuleIcon')
BusinessRulesManager.SetGlobalRuleReferences(GlobalRule)
#Embed(%FinishedApplyingRules,'Finished with applying the Rules')
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9500)
#IF(%LocalRuleCheckAfterOpenWindow)
  #!#IF(ITEMS(%AUXLRules))
BusinessRulesManager.CheckAllRules(1)                    #<!Checking all Rules in RulesManager
  #!#ENDIF
#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'TakeNewSelection','(),BYTE'),PRIORITY(6900)
#IF(%LocalRuleCheckAfterFieldsChange)
  #!#IF(ITEMS(%AUXLRules))
  IF FIELD()
     UPDATE
     BusinessRulesManager.CheckAllRules(True)                 #<!Checking all Rules in RulesManager
     DISPLAY
  END
  #!#ENDIF
#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'TakeAccepted','(),BYTE'),PRIORITY(6400)
#IF(%LocalRuleCheckAfterFieldsChange)
  #!#IF(ITEMS(%AUXLRules))
  IF ACCEPTED()
     UPDATE
     BusinessRulesManager.CheckAllRules(True)                 #<!Checking all Rules in RulesManager
     DISPLAY
  END
  #!#ENDIF
#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'TakeAccepted','(),BYTE'),PRIORITY(2250)
#!#IF(ITEMS(%AUXLRules))
BusinessRulesManager.TakeAccepted(Accepted())                                                      #<!RulesManager traps to determine if error-indicator was clicked
#!#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'TakeCompleted'),PRIORITY(2800)
  #IF(%LocalRuleCheckBeforeUpdate=%True)
IF BusinessRulesManager.CheckAllRules(0)
  RETURN Level:Notify
END
  #ENDIF
#ENDAT

#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                Code Extension
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#Code(dcExternalRulesCodeReadRules,'DinamiComp''s Read Rules into Global Queues/IMDD-Code')
#!
#SHEET
    #PROMPT('Open and Close Rule Files',Check),%LocalOpenCloseRuleFiles,AT(10),DEFAULT(1)
#ENDSHEET

 #IF(%LocalOpenCloseRuleFiles = 1)
 Access:Rules.Open()
 Access:Rules.UseFile()
 #ENDIF
 #IF(%UseIMD=%FALSE)
 Free(RulesQueue)
 RUL:SysIdRule = 0
 Set(RUL:PK_Rules,RUL:PK_Rules)
 Loop
   If Access:Rules.Next() <> Level:Benign THEN BREAK.
   RQ:SysIdRule       = RUL:SysIdRule
   RQ:RuleDescription = Clip(RUL:RuleDescription)
   RQ:RuleExpression  = Clip(RUL:RuleExpression)
   RQ:ControlName     = Clip(RUL:ControlName)
   If Sub(RQ:ControlName,1,1) = '?'
      RQ:ControlName = Sub(RQ:ControlName,2,Len(Clip(RQ:ControlName)))
   End
   RQ:Offset = Clip(RUL:Offset)
   Add(RulesQueue,RQ:ControlName)
   If error() then stop(error()).
 End
 #ELSE
 !#IMD
 Access:%IMDRules.Open()
 Access:%IMDRules.UseFile()
#Embed(%LoadRulesInMemoryTableB,'Load Rules In Memory Table - Begin')
 RUL:SysIdRule = 0
 Set(RUL:PK_Rules,RUL:PK_Rules)
 Loop
   If Access:Rules.Next() <> Level:Benign THEN BREAK.
   IMDRUL:SysIdRule       = RUL:SysIdRule
   IMDRUL:RuleDescription = Clip(RUL:RuleDescription)
   IMDRUL:RuleExpression  = Clip(RUL:RuleExpression)
   IMDRUL:Controlname     = Clip(RUL:ControlName)
   If Sub(IMDRUL:ControlName,1,1) = '?'
      IMDRUL:ControlName = Sub(IMDRUL:ControlName,2,Len(Clip(IMDRUL:ControlName)))
   End
   IMDRUL:Offset = Clip(RUL:Offset)
#Embed(%LoadRulesInMemoryTableBeforeAdd,'Load Rules In Memory Table - BeforeAdd')
   Access:%IMDRules.Insert()
   If error() then stop(error()).
 End
#Embed(%LoadRulesinMemoryTableE,'Load Rules In Memory Table - End')
 Access:%IMDRules.Close()
 #ENDIF
 #IF(%LocalOpenCloseRuleFiles = 1)
 Access:Rules.Close()
 
 Access:ControlsPerRule.Open()
 Access:ControlsPerRule.UseFile()
 #ENDIF

 #IF(%UseIMD=%FALSE)
 Free(RulesControlQueue)
 CPR:SysIdRule            = 0
 CPR:SysIdControlsPerRule = 0
 Set(CPR:FK_ControlePerRule_Rules,CPR:FK_ControlePerRule_Rules)
 Loop
   If Access:ControlsPerRule.Next() <> Level:Benign THEN BREAK.
   RCQ:SysIdRule   = CPR:SysIdRule
   RCQ:ControlName = Clip(CPR:ControlName)
   If Sub(RCQ:ControlName,1,1) = '?'
      RCQ:ControlName = Sub(RCQ:ControlName,2,Len(Clip(RCQ:ControlName)))
   End
   RCQ:RuleAction = Clip(CPR:RuleAction)
   Add(RulesControlQueue,RCQ:SysIdRule)
   If error() then stop(error()).
 End
 #ELSE
 #!IMD
 Access:%IMDControlesPerRule.Open()
 Access:%IMDControlesPerRule.UseFile()
#Embed(%LoadControlsPerRuleInMemoryTableB,'Load Controls Per Rule In Memory Table - Begin')
 CPR:SysIdRule            = 0
 CPR:SysIdControlsPerRule = 0
 Set(CPR:FK_ControlePerRule_Rules,CPR:FK_ControlePerRule_Rules)
 Loop
   If Access:ControlsPerRule.Next() <> Level:Benign THEN BREAK.
   IMDCPR:SysIdRule   = CPR:SysIdRule
   IMDCPR:ControlName = Clip(CPR:ControlName)
   If Sub(IMDCPR:ControlName,1,1) = '?'
      IMDCPR:ControlName = Sub(IMDCPR:ControlName,2,Len(Clip(IMDCPR:ControlName)))
   End
   IMDCPR:RuleAction = Clip(CPR:RuleAction)
   Access:%IMDControlesPerRule.Insert()
   If error() then stop(error()).
 End
#Embed(%LoadControlsPerRuleInMemoryTableE,'Load Controls Per Rule In Memory Table - End')
 Access:%IMDControlesPerRule.Close()
 #END
 #IF(%LocalOpenCloseRuleFiles = 1)
 Access:ControlsPerRule.Close()

 Access:OverrideProcPerRule.Open()
 Access:OverrideProcPerRule.UseFile()
 #ENDIF

 #IF(%UseIMD=%FALSE)
 Free(RulesProcQueue)
 OPR:SysIdRule             = 0
 OPR:SysIDOverrideProcRule = 0
 Set(OPR:FK_OverrideProcPerRule_Rules,OPR:FK_OverrideProcPerRule_Rules)
 Loop
   If Access:OverrideProcPerRule.Next() <> Level:Benign THEN BREAK.
   RPQ:SysIdRule     = OPR:SysIdRule
   RPQ:ProcedureName = Clip(OPR:ProcedureName)
   Add(RulesProcQueue,RPQ:SysIdRule,RPQ:ProcedureName)
   If error() then stop(error()).
 End
 #ELSE
 #!IMD
 Access:%IMDOverrideProcPerRule.Open()
 Access:%IMDOverrideProcPerRule.UseFile()
#Embed(%LoadOverrideProcPerRuleInMemoryTableB,'Load Override Procedure Per Rule In Memory Table - Begin')
 OPR:SysIdRule             = 0
 OPR:SysIDOverrideProcRule = 0
 Set(OPR:FK_OverrideProcPerRule_Rules,OPR:FK_OverrideProcPerRule_Rules)
 Loop
   If Access:OverrideProcPerRule.Next() <> Level:Benign THEN BREAK.
   IMDOPR:SysIdRule     = OPR:SysIdRule
   IMDOPR:ProcedureName = Clip(OPR:ProcedureName)
   Access:%IMDOverrideProcPerRule.Insert()
   If error() then stop(error()).
 End
#Embed(%LoadOverrideProcPerRuleInMemoryTableE,'Load Override Procedure Per Rule In Memory Table - End')
 Access:%IMDOverrideProcPerRule.Close()
 #END
 #IF(%LocalOpenCloseRuleFiles = 1)
 Access:OverrideProcPerRule.Close()
 #ENDIF

#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                Code Extension
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#Code(dcExternalRulesCodeResetRules,'DinamiComp''s Reset Rules into Global Queues/IMDD-Code')
#!

 #IF(%UseIMD=%FALSE)
 Free(RulesQueue)
 RUL:SysIdRule = 0
 Set(RUL:PK_Rules,RUL:PK_Rules)
 Loop
   If Access:Rules.Next() <> Level:Benign THEN BREAK.
   RQ:SysIdRule       = RUL:SysIdRule
   RQ:RuleDescription = Clip(RUL:RuleDescription)
   RQ:RuleExpression  = Clip(RUL:RuleExpression)
   RQ:ControlName     = Clip(RUL:ControlName)
   If Sub(RQ:ControlName,1,1) = '?'
      RQ:ControlName = Sub(RQ:ControlName,2,Len(Clip(RQ:ControlName)))
   End
   RQ:Offset = Clip(RUL:Offset)
   Add(RulesQueue,RQ:ControlName)
   If error() then stop(error()).
 End
 #ELSE
 !#IMD
 Access:%IMDRules.Open()
 Access:%IMDRules.UseFile()
 IMDRUL:SysIdRule = 0
 Set(%IMDRULEKEY,%IMDRULEKEY)
 Loop Until Access:%IMDRules.Next()
      If Not(Error())
         Relate:%IMDRules.Delete(0)
      End
 End
#Embed(%ResetRulesInMemoryTableB,'Load Rules In Memory Table - Begin')
 RUL:SysIdRule = 0
 Set(RUL:PK_Rules,RUL:PK_Rules)
 Loop
   If Access:Rules.Next() <> Level:Benign THEN BREAK.
   IMDRUL:SysIdRule       = RUL:SysIdRule
   IMDRUL:RuleDescription = Clip(RUL:RuleDescription)
   IMDRUL:RuleExpression  = Clip(RUL:RuleExpression)
   IMDRUL:Controlname     = Clip(RUL:ControlName)
   If Sub(IMDRUL:ControlName,1,1) = '?'
      IMDRUL:ControlName = Sub(IMDRUL:ControlName,2,Len(Clip(IMDRUL:ControlName)))
   End
   IMDRUL:Offset = Clip(RUL:Offset)
#Embed(%ResetRulesInMemoryTableBeforeAdd,'Load Rules In Memory Table - BeforeAdd')
   Access:%IMDRules.Insert()
   If error() then stop(error()).
 End
#Embed(%ResetRulesinMemoryTableE,'Load Rules In Memory Table - End')
 Access:%IMDRules.Close()
 #ENDIF

 #IF(%UseIMD=%FALSE)
 Free(RulesControlQueue)
 CPR:SysIdRule            = 0
 CPR:SysIdControlsPerRule = 0
 Set(CPR:FK_ControlePerRule_Rules,CPR:FK_ControlePerRule_Rules)
 Loop
   If Access:ControlsPerRule.Next() <> Level:Benign THEN BREAK.
   RCQ:SysIdRule   = CPR:SysIdRule
   RCQ:ControlName = Clip(CPR:ControlName)
   If Sub(RCQ:ControlName,1,1) = '?'
      RCQ:ControlName = Sub(RCQ:ControlName,2,Len(Clip(RCQ:ControlName)))
   End
   RCQ:RuleAction = Clip(CPR:RuleAction)
   Add(RulesControlQueue,RCQ:SysIdRule)
   If error() then stop(error()).
 End
 #ELSE
 #!IMD
 Access:%IMDControlesPerRule.Open()
 Access:%IMDControlesPerRule.UseFile()
 IMDCPR:SysIdRule = 0
 Set(%IMDControlesPerRuleKey,%IMDControlesPerRuleKey)
 Loop Until Access:%IMDControlesPerRule.Next()
      If Not(Error())
         Relate:%IMDControlesPerRule.Delete(0)
      End
 End
#Embed(%ResetControlsPerRuleInMemoryTableB,'Load Controls Per Rule In Memory Table - Begin')
 CPR:SysIdRule            = 0
 CPR:SysIdControlsPerRule = 0
 Set(CPR:FK_ControlePerRule_Rules,CPR:FK_ControlePerRule_Rules)
 Loop
   If Access:ControlsPerRule.Next() <> Level:Benign THEN BREAK.
   IMDCPR:SysIdRule   = CPR:SysIdRule
   IMDCPR:ControlName = Clip(CPR:ControlName)
   If Sub(IMDCPR:ControlName,1,1) = '?'
      IMDCPR:ControlName = Sub(IMDCPR:ControlName,2,Len(Clip(IMDCPR:ControlName)))
   End
   IMDCPR:RuleAction = Clip(CPR:RuleAction)
   Access:%IMDControlesPerRule.Insert()
   If error() then stop(error()).
 End
#Embed(%ResetControlsPerRuleInMemoryTableE,'Load Controls Per Rule In Memory Table - End')
 Access:%IMDControlesPerRule.Close()
 #END

 #IF(%UseIMD=%FALSE)
 Free(RulesProcQueue)
 OPR:SysIdRule             = 0
 OPR:SysIDOverrideProcRule = 0
 Set(OPR:FK_OverrideProcPerRule_Rules,OPR:FK_OverrideProcPerRule_Rules)
 Loop
   If Access:OverrideProcPerRule.Next() <> Level:Benign THEN BREAK.
   RPQ:SysIdRule     = OPR:SysIdRule
   RPQ:ProcedureName = Clip(OPR:ProcedureName)
   Add(RulesProcQueue,RPQ:SysIdRule,RPQ:ProcedureName)
   If error() then stop(error()).
 End
 #ELSE
 #!IMD
 Access:%IMDOverrideProcPerRule.Open()
 Access:%IMDOverrideProcPerRule.UseFile()
 IMDOPR:SysIdRule = 0
 Set(%IMDOverrideProcPerRuleKey,%IMDOverrideProcPerRuleKey)
 Loop Until Access:%IMDOverrideProcPerRule.Next()
      If Not(Error())
         Relate:%IMDOverrideProcPerRule.Delete(0)
      End
 End

#Embed(%ResetOverrideProcPerRuleInMemoryTableB,'Load Override Procedure Per Rule In Memory Table - Begin')
 OPR:SysIdRule             = 0
 OPR:SysIDOverrideProcRule = 0
 Set(OPR:FK_OverrideProcPerRule_Rules,OPR:FK_OverrideProcPerRule_Rules)
 Loop
   If Access:OverrideProcPerRule.Next() <> Level:Benign THEN BREAK.
   IMDOPR:SysIdRule     = OPR:SysIdRule
   IMDOPR:ProcedureName = Clip(OPR:ProcedureName)
   Access:%IMDOverrideProcPerRule.Insert()
   If error() then stop(error()).
 End
#Embed(%ResetOverrideProcPerRuleInMemoryTableE,'Load Override Procedure Per Rule In Memory Table - End')
 Access:%IMDOverrideProcPerRule.Close()
 #END


#!------------------------------------------------------------------------------------------------------------------------
#GROUP(%SETCC)
  #IMAGE ('Dinamicomp.bmp'),at(5,10)
  #BOXED (''),Section,AT(80,5,110,80)
     #DISPLAY ('DinamiComp''s External'),prop(PROP:FontStyle,700),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Business Rules'),prop(PROP:FontStyle,700),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Version 1.02'),prop(PROP:FontStyle,700),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Copyright  2005 by'),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('DinamiComp Network &&'),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Computer Consultants CC'),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('www.dinamicomp.co.za'),prop(PROP:FontName,%AppTPLFontName)
  #ENDBOXED

#!------------------------------------------------------------------------------------------------------------------------
#GROUP(%SETAPP)
#BOXED('DinamiComp External Rules Templates'),SECTION,AT(,20,,55)
  #DISPLAY ('Define Business Rules in an external file')
  #DISPLAY ('Rules are applied at runtime')
#ENDBOXED

#!------------------------------------------------------------------------------------------------------------------------
#GROUP(%SETRuleQ)
RulesQueue           QUEUE,PRE(RQ)
SysIdRule              LONG
RuleDescription        STRING(255)
RuleExpression         STRING(255)
ControlName            STRING(255)
Offset                 LONG
                     END
RulesControlQueue    QUEUE,PRE(RCQ)
SysIdRule              LONG
ControlName            STRING(255)
RuleAction             BYTE
                     END
RulesProcQueue       QUEUE,PRE(RPQ)
SysIdRule              LONG
ProcedureName          STRING(255)
                     END

#!------------------------------------------------------------------------------------------------------------------------
#GROUP(%SETRuleQExt)
RulesQueue           QUEUE,PRE(RQ),EXTERNAL,DLL(dll_mode)
SysIdRule              LONG
RuleDescription        STRING(255)
RuleExpression         STRING(255)
ControlName            STRING(255)
Offset                 LONG
                     END
RulesControlQueue    QUEUE,PRE(RCQ),EXTERNAL,DLL(dll_mode)
SysIdRule              LONG
ControlName            STRING(255)
RuleAction             BYTE
                     END
RulesProcQueue       QUEUE,PRE(RPQ),EXTERNAL,DLL(dll_mode)
SysIdRule              LONG
ProcedureName          STRING(255)
                     END

!-----------------------------------------------------------------------------------------------------
#GROUP (%StripExclamation,*%zField)
#!-----------------------------------------------------------------------------------------------------
  #IF(SUB(%zField,1,1)='!')
    #SET(%zField,SUB(%zField,2,LEN(%zField)-1))
  #ENDIF
