!----------------------------------------------------------!
! Description: cOCR (OCRClass.Inc)
! Purpose    : Provides the ability to OCR .tif, .bmp and .jpg images
! Owner      : John Dunn
! Updated    : 06/05/2006 clarion mag version 1
! 
!----------------------------------------------------------!

OCRDLLLib                       CLASS,TYPE,LINK('OCRDLL.Lib',_OCRLinkMode_),dll(_OCRDllMode_).

!----------------------------------------------------------!

cOCR                            CLASS,TYPE,MODULE('OCRClass.Clw'),LINK('OCRClass.Clw',_OCRLinkMode_),DLL(_OCRDLLMode_)

! Implemented Classes

! Public methods
AddBackSlash                      PROCEDURE(STRING pPathInfo),STRING
AppCompletePathName               PROCEDURE(),STRING
DeskewImage                       PROCEDURE(),BYTE
DIBToImage                        PROCEDURE(LONG plhDIB),BYTE
DisplayImageInfo                  PROCEDURE(STRING psInputFile),BYTE
EraseBlackBorders                 PROCEDURE(),BYTE
ExtractDirFromPathname            PROCEDURE(STRING pPathInfo,BYTE pAddBackSlash = False),STRING
ExtractNameFromPathname           PROCEDURE(STRING pPathInfo,BYTE pWithExtension = False),STRING
FreeImage                         PROCEDURE()
FreeMultipleImages                PROCEDURE()
GetLastErrNo                      PROCEDURE(),LONG
GetLastError                      PROCEDURE(),STRING
LoadImage                         PROCEDURE(STRING psInputFile),BYTE
LoadMultipleImages                PROCEDURE(STRING psInputFile),BYTE
OCR                               PROCEDURE(STRING psInputFile,LONG plhDIB,UNSIGNED punPageNo),BYTE
ProgramDir                        PROCEDURE(BYTE pAddBackSlash = False),STRING
RemoveBackSlash                   PROCEDURE(STRING pPathInfo),STRING
SetLanguage                       PROCEDURE()
SetOutputMode                     PROCEDURE(LONG plMode)
Trace                             PROCEDURE(STRING psDebugMessage)

! Public properties
bDeskewImage                      BYTE                          ! deskew image
bEraseBlackBorders                BYTE                          ! erase black borders
bLanguage                         BYTE                          ! language
bLoadSingleImage                  BYTE                          ! load single image flag
bOutputToClipboard                BYTE                          ! output to clipboard
bReduceNoise                      BYTE                          ! reduce noise flag
bTraceOn                          BYTE(False)                   ! http class tracing on flag

lLastErrNo                        LONG                          ! last error number
lProgressFEq                      LONG                          ! progress field equate
lOutputTextFEq                    LONG                          ! output text field equate

sDictDir                          STRING(255)                   ! dictionary directory
sLastErrMsg                       STRING(100)                   ! last error message

! Private Methods
Construct                         PROCEDURE(),PRIVATE
Destruct                          PROCEDURE(),PRIVATE
OutputDebugString                 PROCEDURE(STRING psDebugString),PRIVATE
SetLastError                      PROCEDURE(LONG plLastErrNo,STRING psLastErrMsg),PRIVATE

! Private Properties
bImageCount                       BYTE,PRIVATE                  ! image count in multi-image files

lImg                              LONG,PRIVATE                  ! image handle
lNoisy                            LONG,PRIVATE                  ! non zero value if the image is noisy (i.e. contains a lot of speckles)
lOutputHandler                    LONG,PRIVATE                  ! output handler
lOutputHandlerAddress             LONG,PRIVATE                  ! output handler address
lProgressHandler                  LONG,PRIVATE                  ! progress handler
lProgressHandlerAddress           LONG,PRIVATE                  ! progress handler address
lRetVal                           LONG,PRIVATE                  ! return value
lSet                              LONG,PRIVATE                  ! image set handle

szDictDir                         CSTRING(256),PRIVATE          ! dictionary directory
szInputFile                       CSTRING(256),PRIVATE          ! input file
szOutputFile                      CSTRING(256),PRIVATE          ! output file
                                END ! class

!----------------------------------------------------------!
